document.getElementById("SymbioteId").innerHTML = "<I>Detecting...</I>";

var subscription = "";

function onSubscription(event) {
	sLog("Message Type: " + event.kind);

	if (event.kind === "hasInitialized") { hasInitialized(event); }
	if (event.kind === "urlMessageReceived") { urlMessageReceived(event); }

	var sendNotification = (subscription.indexOf(event.kind) > -1);
	if (event.kind === "chatMessageReceived" && (event.payload.body.startsWith("API:") || event.payload.body.startsWith("EVENT:"))) { sendNotification = false; }

	if (sendNotification) {
		TS.players.whoAmI()
			.then((player) => {
				sLog("Symbiote API Sending Event Notification (To Player Id: " + player.id + "): " + JSON.stringify(event));
				TS.chat.send("EVENT:" + JSON.stringify(event), player.id);
			})
			.catch((error) => {
				sLog("Error: " + error);
			});
	}
}

function hasInitialized(event) {
	TS.urls.createUrlPrefixForThisSymbiote()
		.then((id) => {
			sLog("Symbiote API Prefix Id: " + id);
			document.getElementById("SymbioteId").innerHTML = id;
			TS.players.whoAmI().then((player) => {
				sLog("Symbiote API Player Id: " + player.id);
				TS.chat.send("API:" + id, player.id);
			});
		})
		.catch((error) => {
			sLog("Error: " + error);
			document.getElementById("SymbioteId").innerHTML = error;
		});
}

function urlMessageReceived(event) {
	var msg = event.payload.str;
	msg = decodeURIComponent(msg);
	msg = msg.replaceAll("", " "); // Replace ALT+255 with space
	if (msg.toUpperCase().startsWith("API:")) {
		msg = msg.substring(4);
		sLog("Symbiote API Executing: " + msg);
		eval(msg);
		return;
	}
}

function Subscribe(subscribedEventsList) {
	sLog("Symbiote API User Subscribed To Events: " + subscribedEventsList);
	subscription = subscribedEventsList;
}

function sLog(msg) {
	document.getElementById("content").innerHTML = msg + "<BR>\r\n" + document.getElementById("content").innerHTML;
}

var incrementalRollId = 0;

com.bouncyrock.talespire.extra = {

	sendSimpleDiceResult: async function (rolls, gmOnly, quiet) {
		incrementalRollId++;
		var roll = {};
		roll.rollId = (50000000000 + incrementalRollId) + "";
		roll.clientId = (await TS.clients.whoAmI()).id;
		roll.resultsGroups = [];
		for (var i = 0; i < rolls.length; i++) {
			// sLog("Adding Group "+rolls[i].name);
			var dice = rolls[i].roll.substring(rolls[i].roll.toUpperCase().indexOf("D") + 1);
			var mod = 0;
			var op = "+";
			if (dice.indexOf("+") > -1) { mod = dice.substring(dice.indexOf("+") + 1); dice = dice.substring(0, dice.indexOf("+")); }
			if (dice.indexOf("-") > -1) { mod = dice.substring(dice.indexOf("-") + 1); op = "-"; dice = dice.substring(0, dice.indexOf("-")); }
			roll.resultsGroups.push
				(
					{
						"name": rolls[i].name,
						"result":
						{
							"operator": op,
							"operands":
								[
									{ "kind": "d" + dice, "results": rolls[i].results },
									{ "value": parseInt(mod) }
								]
						}
					}
				);
		};
		roll.gmOnly = gmOnly;
		roll.quiet = quiet;
		return await TS.dice.sendDiceResult(roll.resultsGroups, roll.rollId).catch((e) => { sLog(e); });
	},

	getSimpleDiceResult: function (roll) {
		var simple = [];
		for (var i = 0; i < roll.resultsGroups.length; i++) {
			// sLog("Adding Group " + roll.resultsGroups[i].name);
			var entry = {};
			entry.name = roll.resultsGroups[i].name;
			entry.formula = roll.resultsGroups[i].result.operator;
			entry.formula = roll.resultsGroups[i].result.operands[0].kind + entry.formula + (roll.resultsGroups[i].result.operands[1].value | 0);
			entry.formula = roll.resultsGroups[i].result.operands[0].results.length + entry.formula;
			entry.results = roll.resultsGroups[i].result.operands[0].results;
			simple.push(entry);
		};
		return simple;
	}
}
